#include "led.h"

/*
 * Initializes both LEDs
 */
void LED_init(void)
{
	/* Sets the PC0 pin (green led) as output */
	DDRC |= (1 << PC0);
	
	/* Sets the PD7 pin (red led) as output */
	DDRD |= (1 << PD7);
}

/*
 * Flashes the green LED to signal succes
 *
 * @param num - number of flashes
 */
void flash_green(int num)
{
	int i;
	
	/* Turns off the red LED */
	PORTD &= ~(1 << PD7);
	
	for(i = 0; i < num; i++) {
		_delay_ms(FADE_TIME);
		PORTC &= ~(1 << PC0);
		_delay_ms(FADE_TIME);
		PORTC |= (1 << PC0);
	}
}

/*
 * Lights the red LED to signal an error
 */
void light_red(void)
{
	/* Turns off the green LED */
	PORTC &= ~(1 << PC0);

	/* Turns on the red LED to simulate an error */
	PORTD |= (1 << PD7);
	_delay_ms(1000);
	PORTD &= ~(1 << PD7);
}
